<?php
namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class SmOperadorDataSoucerFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * A função "find" Busca os dados para a tela sem ou com filtro
     */
    public function find($filtros) {
        
        $queryDataSource = "SELECT DISTINCT
                                OPER.CDOPERADOR,
                                OPER.NMOPERADOR,
                                OPER.NRPARCNEGOCIO,
                                OPER.NRORG
                            FROM OPERADOR OPER
                            LEFT JOIN FILIOPER FILI ON FILI.CDOPERADOR = OPER.CDOPERADOR
                                                        AND FILI.NRORG = FILI.NRORG
                            LEFT JOIN PERFACESSPARC PERF ON OPER.NRPARCNEGOCIO = PERF.NRPARCNEGOCIO
                                                        AND OPER.NRORG = PERF.NRORG
                            LEFT JOIN  PARCNEGOCIO PARC ON OPER.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                                                        AND OPER.NRORG = PERF.NRORG
                            LEFT JOIN FCT_PERCDESCOPER PERC ON OPER.NRPARCNEGOCIO = PERC.NRPARCNEGOCIO
                                                        AND OPER.NRORG = PERC.NRORG                            
                            WHERE OPER.IDOPERATIVO = 'A' ";
                            
        if (array_key_exists("CDOPERADOR", $filtros)) {
            $queryDataSource .= "AND OPER.CDOPERADOR IN (".$filtros["CDOPERADOR"].") ";
        } 
        if (array_key_exists("NRPERFILACESSO", $filtros)) {
            $queryDataSource .= "AND PERF.NRPERFILACESSO IN (".$filtros["NRPERFILACESSO"].") ";
        } 
        if (array_key_exists("NRPARCNEGOCIO", $filtros)) {
            $queryDataSource .= "AND OPER.NRPARCNEGOCIO IN (SELECT NRPARCNEGRELAC
                                FROM RELACIONAPARC
                                WHERE NRPARCNEGOCIO IN (".$filtros["NRPARCNEGOCIO"].")
                                AND NRTIPORELACIONA = 25)";
        }
        if (array_key_exists("CDFILIAL", $filtros)) {
            $queryDataSource .= "AND FILI.CDFILIAL IN (".$filtros["CDFILIAL"].") ";
        }
        $queryDataSource .= "AND PERC.VRPERCDESC IS NOT NULL ";
        $queryDataSource .= "ORDER BY OPER.NMOPERADOR";
        $std = $this->connection->prepare($queryDataSource);
        $std->execute();
        $returnDataSource = $std->fetchAll();
        return $returnDataSource;
    }
     /**
     * Salva dados na tabela
     */
    public function salvarOperacaoAcresOuDescont(array $params){
        
        $sql= "INSERT INTO FCT_PERCDESCOPER (
                    NRSEQDESC,
                    NRPARCNEGOCIO,
                    VRPERCDESC,
                    NRORG,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    CDOPERULTATU,
                    NRORGULTATU,
                    DTINCLUSAO,
                    IDATIVO,
                    CDSERVORCA,
                    IDTIPO
                )
                VALUES (
                    :NRSEQDESC,
                    :NRPARCNEGOCIO,
                    :VRPERCDESC,
                    :NRORG,
                    :NRORGINCLUSAO,
                    :CDOPERINCLUSAO,
                    :CDOPERULTATU,
                    :NRORGULTATU,
                    SYSDATE,
                    :IDATIVO,
                    :CDSERVORCA,
                    :IDTIPO
                )";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
}
?>