/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODINTDOS                                               */
/* Tabela : PRODINTDOS                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 18/03/2003 - Marcelo Alexsandro Souza Silva                                */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRODINTDOS
BEFORE INSERT OR UPDATE OR DELETE
ON PRODINTDOS FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPDOS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPRODUTO,0) <> NVL(:NEW.CDPRODUTO,0)) THEN
         :NEW.DTULTATUPDOS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODINTDOS', '', 'CDPRODUTO='||:OLD.CDPRODUTO||';CDPRODINTDOS='||:OLD.CDPRODINTDOS||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODINTDOS MODIFY DTULTATUPDOS DEFAULT SYSDATE
/
